/* hread.c
**
** Read a header line of an e-mail.
**
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "inline-funcs.h"
#include "mrmacs.h"

static char *line = NULL;
static size_t lsz = 0;
static int lc = 0;

char *hread_line (FILE *fp, int cont)
{
    size_t l;
    int c, eolm = 1;
    char *p, *ql;
    ifnull (line) {
	lsz = 1024;
	line = galloc (__FILE__, __LINE__, lsz);
    }
    p = line;
    for (;;) {
	++lc;
	while (noNULL(ql = fgets (p, 1024, fp))) {
	    if ((eolm = cuteol (p))) { break; }
	    l = strlen (p) + (p - line);
	    if (lsz - l < 1024) {
		lsz += 1024; line = gresize (__FILE__, __LINE__, line, lsz);
	    }
	    p = &line[l];
	}
	ifnull(ql) {
	    if (p == line) { return NULL; }
	    return line;
	}
	if (!cont || !*line) { break; }
	c = fgetc (fp); ungetc (c, fp);
	if (!isws (c)) { break; }
	strcat(p, (eolm == 1? "\n" : eolm == 2? "\r" : eolm == 3? "\r\n" : ""));
	l = strlen (p) + (p - line);
	if (lsz - l < 1024) {
	    lsz += 1024; line = gresize (__FILE__, __LINE__, line, lsz);
	}
	p = &line[l];
    }
    return line;
}

int hread_lineno (void)
{
    return lc;
}
